﻿/*    
Nemulation: A .NET based framework/platform for virtualization applications
Copyright (C) 2011 Bryan Perris

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace NEmu.TestUnits
{
    [Serializable]
    public sealed class SimpleVMachine : VirtualMachine
    {
        BufferMemory m_Memory;
        TestResourceManger m_Res;

        public SimpleVMachine()
        {
            m_Memory = new BufferMemory(this);
            m_Res = new TestResourceManger(this);
        }

        //public SimpleVMachine(SerializationInfo info, StreamingContext context)
        //    : base(info, context)
        //{
        //    m_Memory = (BufferMemory)info.GetValue("Memory", typeof(BufferMemory));
        //}

        protected override void Boot()
        {
            
        }

        protected override void InitializeComponents()
        {

        }

        protected override void ShutdownComponents()
        {
            
        }

        public override ResourceManager Resources
        {
            get { return m_Res; }
        }

        public override Memory.MemoryUnit MachineMemory
        {
            get { return m_Memory; }
        }
    }
}
