﻿/*    
Nemulation: A .NET based framework/platform for virtualization applications
Copyright (C) 2011 Bryan Perris

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Globalization;

namespace NEmu.Utilities
{
    public static class DataTools
    {
        public static UInt16 BytesToUInt16(byte a, byte b)
        {
            return (UInt16)((UInt16)a << 8 | b);
        }

        public static UInt32 BytesToUInt32(byte a, byte b, byte c, byte d)
        {
            return (UInt32)((a << 24) | (b << 16) | (c << 8) | d);
        }

        public static UInt16 ByteSwap(UInt16 a)
        {
            return (UInt16)(( a << 8 ) | ( a >> 8 ));
        }

        public static string PrintBits(byte value)
        {
            string a = "";
            a += ((value >> 7) & 0x1).ToString(CultureInfo.CurrentCulture);
            a += ((value >> 6) & 0x1).ToString(CultureInfo.CurrentCulture);
            a += ((value >> 5) & 0x1).ToString(CultureInfo.CurrentCulture);
            a += ((value >> 4) & 0x1).ToString(CultureInfo.CurrentCulture);
            a += ((value >> 3) & 0x1).ToString(CultureInfo.CurrentCulture);
            a += ((value >> 2) & 0x1).ToString(CultureInfo.CurrentCulture);
            a += ((value >> 1) & 0x1).ToString(CultureInfo.CurrentCulture);
            a += (value & 0x1).ToString(CultureInfo.CurrentCulture);
            return a;
        }
    }
}
