﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Management.Automation.Host;
using System.Management.Automation;
using System.Collections.ObjectModel;
using System.Security;
using System.Management.Automation.Runspaces;

namespace NEmuVirtualHost.CommandLine
{
    public sealed class ConsoleUserInterface : PSHostUserInterface
    {
        private ConsoleRawUserInterface m_CurrentRawUI;

        public ConsoleUserInterface()
        {
            m_CurrentRawUI = new ConsoleRawUserInterface();
        }


        public override Dictionary<string, System.Management.Automation.PSObject> Prompt(string caption, string message, Collection<FieldDescription> descriptions)
        {
            Dictionary<string, PSObject> paramaters = new Dictionary<string, PSObject>();

            Console.WriteLine("");
            Console.WriteLine(caption);
            Console.WriteLine(message);

            foreach (FieldDescription des in descriptions)
            {
                Console.Write(des.Name + ": ");
                string input = Console.ReadLine();
                paramaters.Add(des.Name, new PSObject(input));
            }

            return paramaters;
        }

        public override int PromptForChoice(string caption, string message, Collection<ChoiceDescription> choices, int defaultChoice)
        {
            throw new NotImplementedException();
        }

        public override PSCredential PromptForCredential(string caption, string message, string userName, string targetName, PSCredentialTypes allowedCredentialTypes, PSCredentialUIOptions options)
        {
            throw new NotImplementedException();
        }

        public override PSCredential PromptForCredential(string caption, string message, string userName, string targetName)
        {
            throw new NotImplementedException();
        }

        public override PSHostRawUserInterface RawUI
        {
            get { return m_CurrentRawUI; }
        }

        public override string ReadLine()
        {
            throw new NotImplementedException();
        }

        public override SecureString ReadLineAsSecureString()
        {
            throw new NotImplementedException();
        }

        public override void Write(ConsoleColor foregroundColor, ConsoleColor backgroundColor, string value)
        {
            throw new NotImplementedException();
        }

        public override void Write(string value)
        {
            throw new NotImplementedException();
        }

        public override void WriteDebugLine(string message)
        {
            throw new NotImplementedException();
        }

        public override void WriteErrorLine(string value)
        {
            Console.BackgroundColor = ConsoleColor.Black;
            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine(value);
            Console.ResetColor();
        }

        public override void WriteLine(string value)
        {
            throw new NotImplementedException();
        }

        public override void WriteProgress(long sourceId, ProgressRecord record)
        {
            throw new NotImplementedException();
        }

        public override void WriteVerboseLine(string message)
        {
            throw new NotImplementedException();
        }

        public override void WriteWarningLine(string message)
        {
            throw new NotImplementedException();
        }
    }
}
